fun hexDigit n =
    if n >= 0 && n <= 9 then
        Char.fromInt (Char.toInt #"0" + n)
    else
        Char.fromInt (Char.toInt #"A" + (n - 10))

fun escape s =
    let
        fun escape i acc =
            if i < 0 then
                acc
            else
                escape (i - 1)
                       ((case String.sub s i of
                             #"\"" => "\\\""
                           | #"\\" => "\\\\"
                           | ch =>
                             if ch = #" " || Char.isPrint ch then
                                 String.str ch
                             else
                                 "\\x" ^ String.str (hexDigit (Char.toInt ch / 16))
                                 ^ String.str (hexDigit (Char.toInt ch % 16))) ^ acc)
    in
        escape (String.length s - 1) ""
    end
